/*+
|                                               |
|     Trigger: DTULTATU_TPNEGOCIACAO            |  
|     Tabela : TPNEGOCIACAO                     |
|                                               |
|     Criao:                                  |
|     06/09/2007 - Leandro Corra Gonalves     |
|                                               |
+*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TPNEGOCIACAO'  and
            type = 'TR'                       and
            u.uid = o.uid                     and
            u.name = USER)
   DROP TRIGGER DTULTATU_TPNEGOCIACAO
GO

CREATE TRIGGER DTULTATU_TPNEGOCIACAO
ON TPNEGOCIACAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
         (SELECT 'TPNEGOCIACAO', 'CDTPNEGOCIACAO='   + CDTPNEGOCIACAO +
                                ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TPNEGOCIACAO
      SET DTULTATUTPNEGO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TPNEGOCIACAO.CDTPNEGOCIACAO, 0) = ISNULL(INSERTED.CDTPNEGOCIACAO, 0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_DIMEDWGRUPOP','5.07.007';
GO

